#include <stdio.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "driver/gpio.h"
#include "driver/spi_master.h"
void CSLOW(void)
{
    gpio_set_level(48, 0);
}
void CSHIGH(void)
{
    gpio_set_level(48, 1);
}

void app_main(void)
{
    spi_device_handle_t spi;
    char buf[] = {1, 2, 3, 4, 5, 6, 7, 8};
    gpio_config_t ioconfig = {
        .mode = GPIO_MODE_OUTPUT,
        .intr_type = GPIO_INTR_DISABLE,
        .pull_up_en = GPIO_PULLUP_ENABLE,
        .pin_bit_mask = (1ULL << 48),
    };
    gpio_config(&ioconfig);
    spi_bus_config_t busconfig = {
        .mosi_io_num = 19,
        .miso_io_num = 20,
        .sclk_io_num = 21,
        .quadhd_io_num = -1,
        .quadwp_io_num = -1,
    };
    spi_bus_initialize(SPI2_HOST, &busconfig, SPI_DMA_CH_AUTO);
    spi_device_interface_config_t devconfig = {
        .spics_io_num = -1,
        .clock_speed_hz = 1000000,
        .mode = 3,
        .queue_size = 3,
        // .post_cb = CSHIGH,
        // .pre_cb = CSLOW,
    };
    spi_bus_add_device(SPI2_HOST, &devconfig, &spi);
    spi_transaction_t t = {
        .length = 8 * 8,
        .tx_buffer = buf,
        .rx_buffer = NULL,
    };
    while (1)
    {
        vTaskDelay(pdMS_TO_TICKS(3000));
        CSLOW();
        spi_device_transmit(spi, &t);
        CSHIGH();
    }
    vTaskDelete(NULL);
}
